package com.whiterabbit.postmanlibsample.commands;

import android.content.Context;
import android.os.Parcel;
import android.util.Log;
import com.whiterabbit.postman.commands.RequestExecutor;
import com.whiterabbit.postman.commands.RestServerRequest;
import com.whiterabbit.postman.exceptions.ResultParseException;
import org.scribe.exceptions.OAuthException;
import org.scribe.model.OAuthRequest;
import org.scribe.model.Response;
import org.scribe.model.Verb;

/**
 * Created with IntelliJ IDEA.
 * User: fedepaol
 * Date: 12/18/12
 * Time: 12:41 AM
 */
public class TwitterUpdateStatusRequest implements RestServerRequest {
    private static final String url = "https://api.twitter.com/1.1/statuses/update.json";
    private String mStatus;


    public TwitterUpdateStatusRequest(String status){
        mStatus = status;
    }

    @Override
    public String getOAuthSigner() {
        return "Twitter";
    }

    @Override
    public String getUrl() {
        return url;
    }

    @Override
    public Verb getVerb() {
        return Verb.POST;
    }

    @Override
    public void onHttpResult(Response result, int statusCode, RequestExecutor executor, Context context) throws ResultParseException {
    }

    @Override
    public void onHttpError(int statusCode, RequestExecutor executor, Context context) {
        Log.e("twitter", "Http error " + statusCode);
    }

    @Override
    public void onOAuthExceptionThrown(OAuthException exception) {
        //TODO Autogenerated
    }

    @Override
    public void addParamsToRequest(OAuthRequest request) {
        request.addBodyParameter("status", mStatus);
    }

    @Override
    public int describeContents() {
        return 0;  //TODO Autogenerated
    }



    public static final Creator<TwitterUpdateStatusRequest> CREATOR
            = new Creator<TwitterUpdateStatusRequest>() {
        public TwitterUpdateStatusRequest createFromParcel(Parcel in) {
            return new TwitterUpdateStatusRequest(in);
        }

        public TwitterUpdateStatusRequest[] newArray(int size) {
            return new TwitterUpdateStatusRequest[size];
        }
    };


    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(mStatus);
    }

    public TwitterUpdateStatusRequest(Parcel in){
        mStatus = in.readString();
    }

}
